unit TstHost;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DataSrc, DB, DBTables;

type
  TfrmTestHost = class(TForm)
    DataHost1: TDataHost;
    tblMaster: TTable;
    tblDetail: TTable;
    dsMaster: TDataSource;
    tblMasterCustNo: TFloatField;
    tblMasterCompany: TStringField;
    tblMasterAddr1: TStringField;
    tblMasterAddr2: TStringField;
    tblMasterCity: TStringField;
    tblMasterState: TStringField;
    tblMasterZip: TStringField;
    tblMasterCountry: TStringField;
    tblMasterPhone: TStringField;
    tblMasterFAX: TStringField;
    tblMasterTaxRate: TFloatField;
    tblMasterContact: TStringField;
    tblMasterLastInvoiceDate: TDateTimeField;
    tblDetailOrderNo: TFloatField;
    tblDetailCustNo: TFloatField;
    tblDetailSaleDate: TDateTimeField;
    tblDetailShipDate: TDateTimeField;
    tblDetailEmpNo: TIntegerField;
    tblDetailShipToContact: TStringField;
    tblDetailShipToAddr1: TStringField;
    tblDetailShipToAddr2: TStringField;
    tblDetailShipToCity: TStringField;
    tblDetailShipToState: TStringField;
    tblDetailShipToZip: TStringField;
    tblDetailShipToCountry: TStringField;
    tblDetailShipToPhone: TStringField;
    tblDetailShipVIA: TStringField;
    tblDetailPO: TStringField;
    tblDetailTerms: TStringField;
    tblDetailPaymentMethod: TStringField;
    tblDetailItemsTotal: TCurrencyField;
    tblDetailTaxRate: TFloatField;
    tblDetailFreight: TCurrencyField;
    tblDetailAmountPaid: TCurrencyField;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure tblMasterBeforeDelete(DataSet: TDataset);
    procedure tblMasterBeforeInsert(DataSet: TDataset);
    procedure tblMasterNewRecord(DataSet: TDataset);
    procedure tblDetailBeforeInsert(DataSet: TDataset);
    procedure tblDetailNewRecord(DataSet: TDataset);
  private
    NewCustNo: Double;
    NewOrderNo: Double;
  end;

var
  frmTestHost: TfrmTestHost;

implementation

{$R *.DFM}

procedure TfrmTestHost.tblMasterBeforeDelete(DataSet: TDataset);
begin
  if not (tblDetail.EOF and tblDetail.BOF) then
    raise Exception.Create('Please delete all detail-records first');
end;

procedure TfrmTestHost.tblMasterBeforeInsert(DataSet: TDataset);
var
  aBookmark: TBookmark;
begin
{ Simulate AutoInc-field, part one: }
  with tblMaster do
  begin
    aBookmark := GetBookmark;
    DisableControls;
    Last;
    NewCustNo := tblMasterCustNo.Value + 1;
    GotoBookmark(aBookmark);
    FreeBookmark(aBookmark);
    EnableControls;
  end;
end;

procedure TfrmTestHost.tblMasterNewRecord(DataSet: TDataset);
begin
{ Simulate AutoInc-field, part two: }
  tblMasterCustNo.Value := NewCustNo;
end;

procedure TfrmTestHost.tblDetailBeforeInsert(DataSet: TDataset);
var
  aBookmark: TBookmark;
  OldIndexFieldNames: String;
begin
{ Simulate AutoInc-field, part one: }
  with tblDetail do
  begin
    aBookmark := GetBookmark;
    DisableControls;
    MasterSource := nil;
    OldIndexFieldNames := IndexFieldNames;
    IndexFieldNames := '';
    Last;
    NewOrderNo := tblDetailOrderNo.Value + 1;
    IndexFieldNames := OldIndexFieldNames;
    MasterSource := dsMaster;
    GotoBookmark(aBookmark);
    FreeBookmark(aBookmark);
    EnableControls;
  end;
end;

procedure TfrmTestHost.tblDetailNewRecord(DataSet: TDataset);
begin
{ Simulate AutoInc-field, part two: }
  tblDetailOrderNo.Value := NewOrderNo;
{ Link to Master: }
  tblDetailCustNo.Value := tblMasterCustNo.Value;
end;

end.
